0 REM  EXAMPLE BASIC PROGRAM TO DRIVE 17XX RAM EXPANSION ON C128
1 REM  FRED BOWEN    COMMODORE BUSINESS MACHINES, INC.
2 REM
3 REM  *** THIS ROUTINE WORKS ON BOTH ORIGINAL & UPDATE ROM SYSTEMS ***
4 REM  SAMPLE PROGRAM AT LINES 10-90.  SAMPLE INPUT:
5 REM                STASH(0) FETCH(0) SWAP(2) ? 0        <- STASH
6 REM                NUMBER OF BYTES           ? 1024     <- OR $400
7 REM                INTERNAL ADDRESS, BANK    ? $2000,0  <- NOTE OPTIONAL HEX
8 REM                EXTERNAL ADDRESS, BANK    ? 0,0      <-   INPUT NEEDS '$'
9 REM
10 INPUT"STASH(0) FETCH(1) SWAP(2)";M:IFM>2THENEND
20 INPUT"NUMBER OF BYTES          ";N$
30 INPUT"INTERNAL ADDRESS, BANK   ";I$,UB
40 INPUT"EXTERNAL ADDRESS, BANK   ";E$,B
50 IFLEFT$(I$,1)="$"THENI=DEC(MID$(I$,2)):ELSEI=VAL(I$)
60 IFLEFT$(E$,1)="$"THENE=DEC(MID$(E$,2)):ELSEE=VAL(E$)
70 IFLEFT$(N$,1)="$"THENN=DEC(MID$(N$,2)):ELSEN=VAL(N$)
80 BANKUB:GOSUB100:PRINT:GOTO1
90 REM
100 REM  FETCH/STASH/SWAP  THE HARD (BUT RIGHT) WAY, BY FRED BOWEN
110 REM
120 REM    ENTER WITH: M = 0 TO STASH
130 REM                    1 TO FETCH
140 REM                    2 TO SWAP
150 REM
160 REM    AND:        N = NUMBER OF BYTES
170 REM                I = INTERNAL ADDRESS
180 REM                E = EXTERNAL ADDRESS
190 REM                B = EXTERNAL BANK
200 REM
210 REM    BE SURE BANK HAS BEEN SETUP VIA 'BANK'
220 REM
230 CB=PEEK(DEC("3D5"))            :REM  SAVE CURRENT SYS BANK (IN SHARED RAM)
240 BANK15                         :REM  NEED SYSTEM  BANK
241 IH=INT(I/256):IL=I-IH*256
242 EH=INT(E/256):EK=E-EH*256
243 NH=INT(N/256):NL=N-NH*256
250 POKEDEC("DF07"),NL             :REM  SETUP NUMBER OF BYTES
260 POKEDEC("DF08"),NH
270 POKEDEC("DF02"),IL             :REM  SETUP INTERNAL ADDRESS
280 POKEDEC("DF03"),IH
290 POKEDEC("DF04"),EK             :REM  SETUP EXTERNAL ADDRESS
300 POKEDEC("DF05"),EH
310 POKEDEC("DF06"),B              :REM  SETUP EXTERNAL BANK
330 BA=PEEK(DEC("F7F0")+CB)
335 VB=PEEK(DEC("D506"))           :REM  SAVE CURRENT VIC BANK (MMU REG #6)
340 POKEDEC("D506"),(VBANDDEC("3F"))OR(BAANDDEC("C0")) :REM  NEW VIC BANK
345 PS=PEEK(DEC("D030"))           :REM  SAVE CURRENT SYS SPEED
350 POKEDEC("D030"),0              :REM  SET SYS SPEED TO 1MHZ
360 SYSDEC("3F0"),BA,,MORDEC("84") :REM  DO DMA PER M
370 POKEDEC("D030"),PS             :REM  RESTORE SYS SPEED
380 POKEDEC("D506"),VB             :REM  RESTORE VIC BANK
390 BANKCB                         :REM  RESTORE SYS BANK
400 RETURN
